From: Quirin Gylstorff <Quirin.Gylstorff@siemens.com>
To: isar-users@googlegroups.com
Subject: [PATCH] expand-on-first-boot: Expand crypto_LUKS partition
Date: Fri, 19 Jan 2024 19:08:11 +0100 [thread overview]
Message-ID: <20240119180833.2097721-1-Quirin.Gylstorff@siemens.com> (raw)
From: Quirin Gylstorff <quirin.gylstorff@siemens.com>
Add the option to expand a encrypted LUKS partition.
A passphrase is required to resize the partition.
If cryptsetup is not installed the service still fails with
an error message.
Signed-off-by: Quirin Gylstorff <quirin.gylstorff@siemens.com>
---
.../files/expand-last-partition.sh | 22 +++++++++++++++----
1 file changed, 18 insertions(+), 4 deletions(-)
diff --git a/meta/recipes-support/expand-on-first-boot/files/expand-last-partition.sh b/meta/recipes-support/expand-on-first-boot/files/expand-last-partition.sh
index 7d658864..94962e40 100755
--- a/meta/recipes-support/expand-on-first-boot/files/expand-last-partition.sh
+++ b/meta/recipes-support/expand-on-first-boot/files/expand-last-partition.sh
@@ -65,14 +65,28 @@ fi
# some filesystems need to be mounted i.e. btrfs, but mounting also helps
# detect the filesystem type without having to wait for udev
# mount $LAST_PART out of tree, so we won't conflict with other mounts
-MOUNT_POINT=$(mktemp -d -p "" "$(basename "$0").XXXXXXXXXX")
-mount "${LAST_PART}" "${MOUNT_POINT}"
-
ret=0
# Determine the filesystem type and perform the appropriate resize function
-FS_TYPE=$(findmnt -fno FSTYPE "${MOUNT_POINT}" )
+FS_TYPE=$(blkid --output value --match-tag TYPE "${LAST_PART}" )
+MOUNT_POINT=$(mktemp -d -p "" "$(basename "$0").XXXXXXXXXX")
+if [ "$FS_TYPE" = "crypto_LUKS" ]; then
+ if [ ! -x /usr/sbin/cryptsetup ]; then
+ echo "'cryptsetup' is missing cannot resize last partition as it is from type 'crypto_LUKS'"
+ exit 1
+ fi
+ last_part_device_name=${LAST_PART#\/dev/}
+
+ mapping_name=$(cat /sys/class/block/"$last_part_device_name"/holders/*/dm/name)
+ cryptsetup resize "$mapping_name"
+ mount /dev/mapper/"$mapping_name" "${MOUNT_POINT}"
+ FS_TYPE=$(findmnt -fno FSTYPE "${MOUNT_POINT}" )
+ LAST_PART=/dev/mapper/"$mapping_name"
+else
+ mount "${LAST_PART}" "${MOUNT_POINT}"
+fi
case ${FS_TYPE} in
ext*)
+
# Do not fail resize2fs if no mtab entry is found, e.g.,
# when using systemd mount units.
export EXT2FS_NO_MTAB_OK=1
--
2.43.0
next reply other threads:[~2024-01-19 18:08 UTC|newest]
Thread overview: 2+ messages / expand[flat|nested] mbox.gz Atom feed top
2024-01-19 18:08 Quirin Gylstorff [this message]
2024-01-26 7:38 ` Uladzimir Bely
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20240119180833.2097721-1-Quirin.Gylstorff@siemens.com \
--to=quirin.gylstorff@siemens.com \
--cc=isar-users@googlegroups.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox